Index: isc-dhcp/client/scripts/freebsd
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/client/scripts/freebsd,v
retrieving revision 1.2
diff -u -r1.2 freebsd
--- isc-dhcp/client/scripts/freebsd	17 Jun 2003 04:24:02 -0000	1.2
+++ isc-dhcp/client/scripts/freebsd	9 Oct 2003 02:25:26 -0000
@@ -1,9 +1,8 @@
 #!/bin/sh
 #
-# $Id: freebsd,v 1.13.2.4 2002/06/09 22:37:55 murray Exp $
-#
-# $FreeBSD: src/contrib/isc-dhcp/client/scripts/freebsd,v 1.9.2.6 2003/03/02 16:42:38 murray Exp $
-# $DragonFly: src/contrib/isc-dhcp/client/scripts/freebsd,v 1.2 2003/06/17 04:24:02 dillon Exp $
+# $Id: freebsd,v 1.13.2.5 2003/04/27 19:44:01 dhankins Exp $
+# $FreeBSD: src/contrib/isc-dhcp/client/scripts/freebsd,v 1.26 2003/09/15 15:48:12 mbr Exp $
+# $DragonFly$
 
 if [ -x /usr/bin/logger ]; then
 	LOGGER="/usr/bin/logger -s -p user.notice -t dhclient"
@@ -14,13 +13,19 @@
 make_resolv_conf() {
   if [ x"$new_domain_name_servers" != x ]; then
     if [ "x$new_domain_name" != x ]; then
-      echo search $new_domain_name >/etc/resolv.conf
+      ( echo search $new_domain_name >/etc/resolv.conf )
+      exit_status=$?
     else
-      rm /etc/resolv.conf
+      ( rm /etc/resolv.conf )
+      exit_status=$?
+    fi
+    if [ $exit_status -ne 0 ]; then
+      $LOGGER "WARNING: Unable to update resolv.conf: Error $exit_status"
+    else
+      for nameserver in $new_domain_name_servers; do
+       ( echo nameserver $nameserver >>/etc/resolv.conf )
+      done
     fi
-    for nameserver in $new_domain_name_servers; do
-      echo nameserver $nameserver >>/etc/resolv.conf
-    done
   fi
 }
 
@@ -45,12 +50,7 @@
   fi
 fi
 
-if [ x$new_network_number != x ]; then
-   $LOGGER New Network Number: $new_network_number
-fi
-
 if [ x$new_broadcast_address != x ]; then
- $LOGGER New Broadcast Address: $new_broadcast_address
   new_broadcast_arg="broadcast $new_broadcast_address"
 fi
 if [ x$old_broadcast_address != x ]; then
@@ -66,6 +66,15 @@
   alias_subnet_arg="netmask $alias_subnet_mask"
 fi
 
+# Get the interface to which our default route is bound to.
+if [ -x /usr/bin/netstat ]; then
+	if_defaultroute=`/usr/bin/netstat -rn \
+		| /usr/bin/grep "^default" \
+		| /usr/bin/awk '{print $6}'`
+else
+	if_defaultroute="x"
+fi
+
 if [ x$reason = xMEDIUM ]; then
   eval "ifconfig $interface $medium"
   eval "ifconfig $interface inet -alias 0.0.0.0 $medium" >/dev/null 2>&1
@@ -161,7 +170,9 @@
     eval "ifconfig $interface inet -alias $old_ip_address $medium"
     route delete $old_ip_address 127.1 >/dev/null 2>&1
     for router in $old_routers; do
-      route delete default $router >/dev/null 2>&1
+      if [ $if_defaultroute = x ] || [ $if_defaultroute = $interface ]; then
+	      route delete default $router >/dev/null 2>&1
+      fi
     done
     if [ -n "$old_static_routes" ]; then
       set -- $old_static_routes
Index: isc-dhcp/common/discover.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/common/discover.c,v
retrieving revision 1.1
diff -u -r1.1 discover.c
--- isc-dhcp/common/discover.c	17 Jun 2003 02:44:59 -0000	1.1
+++ isc-dhcp/common/discover.c	9 Oct 2003 02:26:23 -0000
@@ -39,13 +39,11 @@
  * ``http://www.isc.org/''.  To learn more about Vixie Enterprises,
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
+ * 
+ * $Id: discover.c,v 1.42.2.14 2003/07/25 19:44:15 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.
+ * $DragonFly$
  */
 
-#ifndef lint
-static char copyright[] =
-"$Id: discover.c,v 1.42.2.13 2002/11/17 02:26:57 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.\n";
-#endif /* not lint */
-
 #include "dhcpd.h"
 #include <sys/ioctl.h>
 
@@ -258,10 +256,12 @@
 			if (!strcmp (tmp -> name, ifp -> ifr_name))
 				break;
 
-		/* Skip loopback, point-to-point and down interfaces,
-		   except don't skip down interfaces if we're trying to
-		   get a list of configurable interfaces. */
-		if (((ifr.ifr_flags & IFF_LOOPBACK ||
+		/* Skip non broadcast interfaces (plus loopback and
+		   point-to-point in case an OS incorrectly marks them
+		   as broadcast). Also skip down interfaces unless we're
+		   trying to get a list of configurable interfaces. */
+		if (((!(ifr.ifr_flags & IFF_BROADCAST) ||
+		      ifr.ifr_flags & IFF_LOOPBACK ||
 		      ifr.ifr_flags & IFF_POINTOPOINT) && !tmp) ||
 		    (!(ifr.ifr_flags & IFF_UP) &&
 		     state != DISCOVER_UNCONFIGURED))
Index: isc-dhcp/common/dispatch.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/common/dispatch.c,v
retrieving revision 1.1
diff -u -r1.1 dispatch.c
--- isc-dhcp/common/dispatch.c	17 Jun 2003 02:44:59 -0000	1.1
+++ isc-dhcp/common/dispatch.c	9 Oct 2003 02:26:44 -0000
@@ -39,18 +39,22 @@
  * ``http://www.isc.org/''.  To learn more about Vixie Enterprises,
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
+ *
+ * $Id: dispatch.c,v 1.63.2.3 2002/11/17 02:26:57 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.
+ * $FreeBSD: src/contrib/isc-dhcp/common/dispatch.c,v 1.4 2003/08/10 22:01:37 mbr Exp $
+ * $DragonFly$
  */
 
-#ifndef lint
-static char copyright[] =
-"$Id: dispatch.c,v 1.63.2.3 2002/11/17 02:26:57 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.\n";
-#endif /* not lint */
 
 #include "dhcpd.h"
 
 struct timeout *timeouts;
 static struct timeout *free_timeouts;
 
+#ifdef ENABLE_POLLING_MODE
+extern int polling_interval;
+#endif
+
 void set_time (u_int32_t t)
 {
 	/* Do any outstanding timeouts. */
@@ -95,11 +99,26 @@
 void dispatch ()
 {
 	struct timeval tv, *tvp;
+#ifdef ENABLE_POLLING_MODE
+	struct timeval *tvp_new;
+#endif
 	isc_result_t status;
+	TIME cur_time;
 
+	tvp = NULL;
+#ifdef ENABLE_POLLING_MODE
+	tvp_new = NULL;
+#endif
 	/* Wait for a packet or a timeout... XXX */
 	do {
 		tvp = process_outstanding_timeouts (&tv);
+#ifdef ENABLE_POLLING_MODE
+		GET_TIME (&cur_time);
+		add_timeout(cur_time + polling_interval, state_polling, 0, 0, 0);
+		tvp_new = process_outstanding_timeouts(&tv);
+		if (tvp != NULL && (tvp -> tv_sec > tvp_new -> tv_sec))
+			tvp = tvp_new;
+#endif /* ENABLE_POLLING_MODE */
 		status = omapi_one_dispatch (0, tvp);
 	} while (status == ISC_R_TIMEDOUT || status == ISC_R_SUCCESS);
 	log_fatal ("omapi_one_dispatch failed: %s -- exiting.",
Index: isc-dhcp/common/options.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/common/options.c,v
retrieving revision 1.1
diff -u -r1.1 options.c
--- isc-dhcp/common/options.c	17 Jun 2003 02:45:00 -0000	1.1
+++ isc-dhcp/common/options.c	9 Oct 2003 02:27:08 -0000
@@ -39,13 +39,11 @@
  * ``http://www.isc.org/''.  To learn more about Vixie Enterprises,
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
+ *
+ * $Id: options.c,v 1.85.2.12 2003/03/31 03:06:55 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.
+ * $DragonFly$
  */
 
-#ifndef lint
-static char copyright[] =
-"$Id: options.c,v 1.85.2.9 2002/11/17 02:26:58 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.\n";
-#endif /* not lint */
-
 #define DHCP_OPTION_DATA
 #include "dhcpd.h"
 #include <omapip/omapip_p.h>
@@ -166,15 +164,36 @@
 		   the parse fails, or the option isn't an encapsulation (by
 		   far the most common case), or the option isn't entirely
 		   an encapsulation, keep the raw data as well. */
-		if (!((universe -> options [code] -> format [0] == 'e' ||
+		if (universe -> options [code] &&
+		    !((universe -> options [code] -> format [0] == 'e' ||
 		       universe -> options [code] -> format [0] == 'E') &&
 		      (parse_encapsulated_suboptions
 		       (options, universe -> options [code],
 			buffer + offset + 2, len,
 			universe, (const char *)0)))) {
-		    save_option_buffer (universe, options, bp,
-					&bp -> data [offset + 2], len,
-					universe -> options [code], 1);
+		    op = lookup_option (universe, options, code);
+		    if (op) {
+			struct data_string new;
+			memset (&new, 0, sizeof new);
+			if (!buffer_allocate (&new.buffer, op -> data.len + len,
+					      MDL)) {
+			    log_error ("parse_option_buffer: No memory.");
+			    return 0;
+			}
+			memcpy (new.buffer -> data, op -> data.data,
+				op -> data.len);
+			memcpy (&new.buffer -> data [op -> data.len],
+				&bp -> data [offset + 2], len);
+			new.len = op -> data.len + len;
+			new.data = new.buffer -> data;
+			data_string_forget (&op -> data, MDL);
+			data_string_copy (&op -> data, &new, MDL);
+			data_string_forget (&new, MDL);
+		    } else {
+			save_option_buffer (universe, options, bp,
+					    &bp -> data [offset + 2], len,
+					    universe -> options [code], 1);
+		    }
 		}
 		offset += len + 2;
 	}
@@ -470,14 +489,18 @@
 	   and no alternate maximum message size has been specified, take the
 	   one in the packet. */
 
-	if (!mms && inpacket &&
+	if (inpacket &&
 	    (op = lookup_option (&dhcp_universe, inpacket -> options,
 				 DHO_DHCP_MAX_MESSAGE_SIZE))) {
 		evaluate_option_cache (&ds, inpacket,
 				       lease, client_state, in_options,
 				       cfg_options, scope, op, MDL);
-		if (ds.len >= sizeof (u_int16_t))
-			mms = getUShort (ds.data);
+		if (ds.len >= sizeof (u_int16_t)) {
+			i = getUShort (ds.data);
+
+			if(!mms || (i < mms))
+				mms = i;
+		}
 		data_string_forget (&ds, MDL);
 	}
 
Index: isc-dhcp/common/parse.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/common/parse.c,v
retrieving revision 1.1
diff -u -r1.1 parse.c
--- isc-dhcp/common/parse.c	17 Jun 2003 02:45:00 -0000	1.1
+++ isc-dhcp/common/parse.c	9 Oct 2003 02:27:32 -0000
@@ -39,12 +39,11 @@
  * ``http://www.isc.org/''.  To learn more about Vixie Enterprises,
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
+ * 
+ * $Id: parse.c,v 1.104.2.14 2003/07/25 19:36:11 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.
+ * $DragonFly$
  */
 
-#ifndef lint
-static char copyright[] =
-"$Id: parse.c,v 1.104.2.12 2002/11/17 02:58:34 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.\n";
-#endif /* not lint */
 
 #include "dhcpd.h"
 
@@ -284,8 +283,11 @@
 		name = parse_host_name (cfile);
 		if (!name)
 			return 0;
-		if (!make_host_lookup (expr, name))
+		if (!make_host_lookup (expr, name)) {
+			dfree(name, MDL);
 			return 0;
+		}
+		dfree(name, MDL);
 		if (!uniform) {
 			if (!make_limit (&x, *expr, 4))
 				return 0;
@@ -4040,7 +4042,11 @@
 	}
 
 	if (binop != expr_none) {
-	  if (expression_context (rhs) != expression_context (lhs)) {
+	  rhs_context = expression_context(rhs);
+	  lhs_context = expression_context(lhs);
+
+	  if ((rhs_context != context_any) && (lhs_context != context_any) &&
+			(rhs_context != lhs_context)) {
 	    parse_warn (cfile, "illegal expression relating different types");
 	    skip_to_semi (cfile);
 	    expression_dereference (&rhs, MDL);
@@ -4052,9 +4058,10 @@
 	  switch(binop) {
 	    case expr_not_equal:
 	    case expr_equal:
-		if ((expression_context(rhs) != context_data_or_numeric) &&
-		    (expression_context(rhs) != context_data) &&
-		    (expression_context(rhs) != context_numeric)) {
+		if ((rhs_context != context_data_or_numeric) &&
+		    (rhs_context != context_data) &&
+		    (rhs_context != context_numeric) &&
+		    (rhs_context != context_any)) {
 			parse_warn (cfile, "expecting data/numeric expression");
 			skip_to_semi (cfile);
 			expression_dereference (&rhs, MDL);
@@ -4065,7 +4072,8 @@
 
 	    case expr_and:
 	    case expr_or:
-		if (expression_context(rhs) != context_boolean) {
+		if ((rhs_context != context_boolean) &&
+		    (rhs_context != context_any)) {
 			parse_warn (cfile, "expecting boolean expressions");
 			skip_to_semi (cfile);
 			expression_dereference (&rhs, MDL);
@@ -4082,7 +4090,8 @@
 	    case expr_binary_and:
 	    case expr_binary_or:
 	    case expr_binary_xor:
-		if (expression_context(rhs) != context_numeric) {
+		if ((rhs_context != context_numeric) &&
+		    (rhs_context != context_any)) {
 			parse_warn (cfile, "expecting numeric expressions");
                         skip_to_semi (cfile);
                         expression_dereference (&rhs, MDL);
Index: isc-dhcp/common/print.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/common/print.c,v
retrieving revision 1.1
diff -u -r1.1 print.c
--- isc-dhcp/common/print.c	17 Jun 2003 02:45:00 -0000	1.1
+++ isc-dhcp/common/print.c	9 Oct 2003 02:27:44 -0000
@@ -3,7 +3,7 @@
    Turn data structures into printable text. */
 
 /*
- * Copyright (c) 1995-2002 Internet Software Consortium.
+ * Copyright (c) 1995-2003 Internet Software Consortium.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,12 +39,11 @@
  * ``http://www.isc.org/''.  To learn more about Vixie Enterprises,
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
+ * 
+ * $Id: print.c,v 1.53.2.9 2003/03/31 03:06:56 dhankins Exp $ Copyright (c) 1995-2003 The Internet Software Consortium.  All rights reserved.
+ * $DragonFly$
  */
 
-#ifndef lint
-static char copyright[] =
-"$Id: print.c,v 1.53.2.7 2002/11/17 02:26:59 dhankins Exp $ Copyright (c) 1995-2002 The Internet Software Consortium.  All rights reserved.\n";
-#endif /* not lint */
 
 #include "dhcpd.h"
 
@@ -223,7 +222,7 @@
 	       lease -> host ? lease -> host -> name : "<none>");
 }	
 
-#if defined (DEBUG)
+#if defined (DEBUG_PACKET)
 void dump_packet_option (struct option_cache *oc,
 			 struct packet *packet,
 			 struct lease *lease,
@@ -304,19 +303,46 @@
 	char lbuf [80];
 	int lbix = 0;
 
-	lbuf [0] = 0;
+/*
+          1         2         3         4         5         6         7
+01234567890123456789012345678901234567890123456789012345678901234567890123
+280: 00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00   .................  
+*/
+
+	memset(lbuf, ' ', 79);
+	lbuf [79] = 0;
 
 	for (i = 0; i < len; i++) {
 		if ((i & 15) == 0) {
-			if (lbix)
-				log_info (lbuf);
-			sprintf (lbuf, "%03x:", i);
-			lbix = 4;
+		  if (lbix) {
+		    	lbuf[53]=' ';
+			lbuf[54]=' ';
+			lbuf[55]=' ';
+			lbuf[73]='\0';
+			log_info (lbuf);
+		  }
+		  memset(lbuf, ' ', 79);
+		  lbuf [79] = 0;
+		  sprintf (lbuf, "%03x:", i);
+		  lbix = 4;
 		} else if ((i & 7) == 0)
 			lbuf [lbix++] = ' ';
+
+		if(isprint(buf[i])) {
+		  lbuf[56+(i%16)]=buf[i];
+		} else {
+		  lbuf[56+(i%16)]='.';
+		}
+
 		sprintf (&lbuf [lbix], " %02x", buf [i]);
 		lbix += 3;
+		lbuf[lbix]=' ';
+
 	}
+	lbuf[53]=' ';
+	lbuf[54]=' ';
+	lbuf[55]=' ';
+	lbuf[73]='\0';
 	log_info (lbuf);
 }
 
@@ -337,7 +363,7 @@
 			if (bp -> len)
 				dump_raw (bp -> name, bp -> len);
 			else
-				log_info ((const char *)bp -> name);
+				log_info ("%s", (const char *)bp -> name);
 		}
 	}
 }
@@ -1248,6 +1274,9 @@
 		      case T_TXT:
 			en = "TXT";
 			break;
+		      case T_KEY:
+			en = "KEY";
+			break;
 		      case T_CNAME:
 			en = "CNAME";
 			break;
@@ -1268,13 +1297,19 @@
 				if (s + 1 < end)
 					*s++ = '"';
 			}
-			if (s + u -> r_size < end) {
-				memcpy (s, u -> r_data, u -> r_size);
-				s += u -> r_size;
-				if (u -> r_type == T_TXT) {
-					if (s + 1 < end)
-						*s++ = '"';
-				}
+			if(u->r_type == T_KEY) {
+			  strcat(s, "<keydata>");
+			  s+=strlen("<keydata>");
+			}
+			else {  
+			  if (s + u -> r_size < end) {
+			    memcpy (s, u -> r_data, u -> r_size);
+			    s += u -> r_size;
+			    if (u -> r_type == T_TXT) {
+			      if (s + 1 < end)
+				*s++ = '"';
+			    }
+			  }
 			}
 		}
 		if (position) {
